<template lang="pug">
q-card.q-ma-md(style="height: min-content")
  q-card-section.q-pb-none
    q-form.row.items-center.no-wrap.q-pb-md(@submit="handleSaveName")
      div
        .text-bold(v-if="!editingName") {{ roomName }}:
        q-input(
          v-if="editingName",
          v-model="editNameValue",
          :disable="saveNameLoading",
          filled,
          :rules="[(val) => (val && val.length) || 'Name cannot be empty', (val) => val === roomName || !roomExists(val) || 'Name must be unique']"
        )
      q-space
      q-btn.q-ml-sm(
        v-if="!editingName",
        icon="edit",
        round,
        flat,
        size="0.6rem",
        @click="(editingName = true), (editNameValue = roomName)"
      )
      .row.items-center.q-pb-md.no-wrap(v-if="editingName")
        q-btn.q-ml-sm(
          @click="editingName = false",
          :disabled="saveNameLoading",
          icon="close",
          color="negative",
          size="0.6rem",
          flat,
          round
        )
        q-btn.q-ml-sm(
          @click="handleSaveName",
          color="positive",
          icon="done",
          round,
          flat,
          size="0.6rem",
          :loading="saveNameLoading"
        )
  q-card-section.q-pt-sm
    q-list(dense, separator)
      draggable(
        handle=".drag-handle",
        :list="room",
        group="people",
        @end="onParticipantDragDropped"
      )
        q-item(
          v-for="(user, uid) in room",
          :key="uid",
          style="background-color: white"
        )
          q-item-section(side)
            q-icon.drag-handle(name="drag_handle", style="cursor: pointer")
          q-item-section(v-if="user.userRole === 'Sensor'") {{ user.username }} (Sensor)
          q-item-section(v-else) {{ user.username }} ({{ user.userId }})
      q-item(v-if="!(room || []).length")
        q-item-section No Users in Room
</template>
<script>
import draggable from "vuedraggable";

export default {
  props: {
    room: {
      required: true,
    },
    roomName: {
      required: true,
    },
    // Callback for when a participant in the list is dragged and dropped
    onParticipantDragDropped: {
      required: true,
    },
    // Callback for when the user saves their name edit
    editName: {
      required: true,
    },
    // Whether room with `name` exists
    roomExists: {
      required: true,
    },
  },
  data() {
    return {
      editingName: false,
      editNameValue: "",
      saveNameLoading: false,
    };
  },
  methods: {
    async handleSaveName() {
      this.saveNameLoading = true;
      await this.editName(this.roomName, this.editNameValue);
      this.saveNameLoading = false;
      this.editingName = false;
    },
  },
  components: {
    draggable,
  },
};
</script>